/* Flag combinations */
#ifdef RENAME_NODES
#ifndef COORD_BISEC
#error You must define COORD_BISEC with RENAME_NODES
#endif
#endif

#ifdef RENAME_EDGES
#if (!defined(COORD_BISEC) || !defined(RENAME_NODES))
#error You must define COORD_BISEC and RENAME_NODES with RENAME_EDGES
#endif
#endif

#ifdef RENAME_FACES
#if (!defined(COORD_BISEC) || !defined(RENAME_NODES))
#error You must define COORD_BISEC and RENAME_NODES with RENAME_FACES
#endif
#endif

#if (defined(DIRECT_REDUCTION) && (SHM_REDUCTION))
#error You must define only ONE of the the three reductions
#endif

#if (defined(DIRECT_REDUCTION) && (BULK_REDUCTION))
#error You must define only ONE of the the three reductions
#endif

#if (defined(BULK_REDUCTION) && (SHM_REDUCTION))
#error You must define only ONE of the the three reductions
#endif

#if (defined(SHM_REDUCTION) && defined(USE_ACK_UPDATES))
#error shm_reduction should not be used with update protocol
#endif

#if (defined(SHM_REDUCTION) || defined(BULK_REDUCTION) || defined(DIRECT_REDUCTION))
#ifndef NO_LOCKING
#error Must define NO_LOCKING with one of the three reductions
#endif
#endif

#ifdef PARTIAL_MEMORY_UPDATES
#define MEMORY_UPDATES
#endif

#ifdef MEMORY_UPDATES
#if (!defined(COORD_BISEC) && !defined(RENAME_NODES))
#error You must define either COORD_BISEC or RENAME_NODES with MEMORY_UPDATES
#endif
#endif

#if (defined(FINE_UPDATES) || defined(MEMORY_UPDATES))
#ifndef NO_LOCKING
#error Must define NO_LOCKING with update protocol
#endif
#ifdef STACHE_FAULT_INFO
#error Fault info not collectible with FINE_UPDATES or MEMORY_UPDATES
#endif
#endif

#ifdef FINE_UPDATES
#ifdef SHM_REDUCTION
#error FINE_UPDATES may not work with SHM_REDUCTION
#endif
#endif

#if (defined(FINE_UPDATES) && defined(MEMORY_UPDATES))
#error You cannot define both FINE_UPDATES and MEMORY_UPDATES
#endif

